diff -ruN tarsnap-autoconf-1.0.33/libcperciva/events/events_network.c tarsnap-autoconf-1.0.34/libcperciva/events/events_network.c
--- tarsnap-autoconf-1.0.33/libcperciva/events/events_network.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/events/events_network.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,346 @@
+#include <sys/select.h>
+
+#include <errno.h>
+#include <stdlib.h>
+
+#include "elasticarray.h"
+#include "warnp.h"
+
+#include "events_internal.h"
+#include "events.h"
+
+/* Structure for holding readability and writability events for a socket. */
+struct socketrec {
+	struct eventrec * reader;
+	struct eventrec * writer;
+};
+
+/* List of sockets. */
+ELASTICARRAY_DECL(SOCKETLIST, socketlist, struct socketrec);
+static SOCKETLIST S = NULL;
+
+/* File descriptor sets containing unevented ready sockets. */
+static fd_set readfds;
+static fd_set writefds;
+
+/* Position to which events_network_get has scanned in *fds. */
+static size_t fdscanpos;
+
+/* Number of registered events. */
+static size_t nev;
+
+/* Initialize the socket list if we haven't already done so. */
+static int
+initsocketlist(void)
+{
+
+	/* If we're already initialized, do nothing. */
+	if (S != NULL)
+		goto done;
+
+	/* Initialize the socket list. */
+	if ((S = socketlist_init(0)) == NULL)
+		goto err0;
+
+	/* There are no events registered. */
+	nev = 0;
+
+	/* There are no unevented ready sockets. */
+	fdscanpos = FD_SETSIZE;
+
+done:
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/* Grow the socket list and initialize new records. */
+static int
+growsocketlist(size_t nrec)
+{
+	size_t i;
+
+	/* Get the old size. */
+	i = socketlist_getsize(S);
+
+	/* Grow the list. */
+	if (socketlist_resize(S, nrec))
+		goto err0;
+
+	/* Initialize new members. */
+	for (; i < nrec; i++) {
+		socketlist_get(S, i)->reader = NULL;
+		socketlist_get(S, i)->writer = NULL;
+	}
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * events_network_register(func, cookie, s, op):
+ * Register ${func}(${cookie}) to be run when socket ${s} is ready for
+ * reading or writing depending on whether ${op} is EVENTS_NETWORK_OP_READ or
+ * EVENTS_NETWORK_OP_WRITE.  If there is already an event registration for
+ * this ${s}/${op} pair, errno will be set to EEXIST and the function will
+ * fail.
+ */
+int
+events_network_register(int (*func)(void *), void * cookie, int s, int op)
+{
+	struct eventrec ** r;
+
+	/* Initialize if necessary. */
+	if (initsocketlist())
+		goto err0;
+
+	/* Sanity-check socket number. */
+	if ((s < 0) || (s >= (int)FD_SETSIZE)) {
+		warn0("Invalid file descriptor for network event: %d", s);
+		goto err0;
+	}
+
+	/* Sanity-check operation. */
+	if ((op != EVENTS_NETWORK_OP_READ) &&
+	    (op != EVENTS_NETWORK_OP_WRITE)) {
+		warn0("Invalid operation for network event: %d", op);
+		goto err0;
+	}
+
+	/* Grow the array if necessary. */
+	if (((size_t)(s) >= socketlist_getsize(S)) &&
+	    (growsocketlist(s + 1) != 0))
+		goto err0;
+
+	/* Look up the relevant event pointer. */
+	if (op == EVENTS_NETWORK_OP_READ)
+		r = &socketlist_get(S, s)->reader;
+	else
+		r = &socketlist_get(S, s)->writer;
+
+	/* Error out if we already have an event registered. */
+	if (*r != NULL) {
+		errno = EEXIST;
+		goto err0;
+	}
+
+	/* Register the new event. */
+	if ((*r = events_mkrec(func, cookie)) == NULL)
+		goto err0;
+
+	/*
+	 * Increment events-registered counter; and if it was zero, start the
+	 * inter-select duration clock.
+	 */
+	if (nev++ == 0)
+		events_network_selectstats_startclock();
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * events_network_cancel(s, op):
+ * Cancel the event registered for the socket/operation pair ${s}/${op}.  If
+ * there is no such registration, errno will be set to ENOENT and the
+ * function will fail.
+ */
+int
+events_network_cancel(int s, int op)
+{
+	struct eventrec ** r;
+
+	/* Initialize if necessary. */
+	if (initsocketlist())
+		goto err0;
+
+	/* Sanity-check socket number. */
+	if ((s < 0) || (s >= (int)FD_SETSIZE)) {
+		warn0("Invalid file descriptor for network event: %d", s);
+		goto err0;
+	}
+
+	/* Sanity-check operation. */
+	if ((op != EVENTS_NETWORK_OP_READ) &&
+	    (op != EVENTS_NETWORK_OP_WRITE)) {
+		warn0("Invalid operation for network event: %d", op);
+		goto err0;
+	}
+
+	/* We have no events registered beyond the end of the array. */
+	if ((size_t)(s) >= socketlist_getsize(S)) {
+		errno = ENOENT;
+		goto err0;
+	}
+
+	/* Look up the relevant event pointer. */
+	if (op == EVENTS_NETWORK_OP_READ)
+		r = &socketlist_get(S, s)->reader;
+	else
+		r = &socketlist_get(S, s)->writer;
+
+	/* Check if we have an event. */
+	if (*r == NULL) {
+		errno = ENOENT;
+		goto err0;
+	}
+
+	/* Free the event. */
+	events_freerec(*r);
+	*r = NULL;
+
+	/*
+	 * Since there is no longer an event registered for this socket /
+	 * operation pair, it doesn't make any sense for it to be ready.
+	 */
+	if (op == EVENTS_NETWORK_OP_READ)
+		FD_CLR(s, &readfds);
+	else
+		FD_CLR(s, &writefds);
+
+	/*
+	 * Decrement events-registered counter; and if it is becoming zero,
+	 * stop the inter-select duration clock.
+	 */
+	if (--nev == 0)
+		events_network_selectstats_stopclock();
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * events_network_select(tv):
+ * Check for socket readiness events, waiting up to ${tv} time if there are
+ * no sockets immediately ready, or indefinitely if ${tv} is NULL.
+ */
+int
+events_network_select(struct timeval * tv)
+{
+	size_t i;
+
+	/* Initialize if necessary. */
+	if (initsocketlist())
+		goto err0;
+
+	/* Zero the fd sets... */
+	FD_ZERO(&readfds);
+	FD_ZERO(&writefds);
+
+	/* ... and add the ones we care about. */
+	for (i = 0; i < socketlist_getsize(S); i++) {
+		if (socketlist_get(S, i)->reader)
+			FD_SET(i, &readfds);
+		if (socketlist_get(S, i)->writer)
+			FD_SET(i, &writefds);
+	}
+
+	/* We're about to call select! */
+	events_network_selectstats_select();
+
+	/* Select. */
+	while (select(socketlist_getsize(S), &readfds, &writefds,
+	    NULL, tv) == -1) {
+		/* EINTR is harmless. */
+		if (errno == EINTR)
+			continue;
+
+		/* Anything else is an error. */
+		warnp("select()");
+		goto err0;
+	}
+
+	/* If we have any events registered, start the clock again. */
+	if (nev > 0)
+		events_network_selectstats_startclock();
+
+	/* We should start scanning for events at the beginning. */
+	fdscanpos = 0;
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * events_network_get(void):
+ * Find a socket readiness event which was identified by a previous call to
+ * events_network_select, and return it as an eventrec structure; or return
+ * NULL if there are no such events available.  The caller is responsible for
+ * freeing the returned memory.
+ */
+struct eventrec *
+events_network_get(void)
+{
+	struct eventrec * r;
+	size_t nfds = socketlist_getsize(S);
+
+	/* We haven't found any events yet. */
+	r = NULL;
+
+	/* Scan through the fd sets looking for ready sockets. */
+	for (; fdscanpos < nfds; fdscanpos++) {
+		/* Are we ready for reading? */
+		if (FD_ISSET(fdscanpos, &readfds)) {
+			r = socketlist_get(S, fdscanpos)->reader;
+			socketlist_get(S, fdscanpos)->reader = NULL;
+			if (--nev == 0)
+				events_network_selectstats_stopclock();
+			FD_CLR(fdscanpos, &readfds);
+			break;
+		}
+
+		/* Are we ready for writing? */
+		if (FD_ISSET(fdscanpos, &writefds)) {
+			r = socketlist_get(S, fdscanpos)->writer;
+			socketlist_get(S, fdscanpos)->writer = NULL;
+			if (--nev == 0)
+				events_network_selectstats_stopclock();
+			FD_CLR(fdscanpos, &writefds);
+			break;
+		}
+	}
+
+	/* Return the event we found, or NULL if we didn't find any. */
+	return (r);
+}
+
+/**
+ * events_network_shutdown(void)
+ * Clean up and free memory.  This call is not necessary on program exit and
+ * is only expected to be useful when checking for memory leaks.
+ */
+void
+events_network_shutdown(void)
+{
+
+	/* If we're not initialized, do nothing. */
+	if (S == NULL)
+		return;
+
+	/* If we have any registered events, do nothing. */
+	if (nev > 0)
+		return;
+
+	/* Free the socket list. */
+	socketlist_free(S);
+	S = NULL;
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/events/events_network_selectstats.c tarsnap-autoconf-1.0.34/libcperciva/events/events_network_selectstats.c
--- tarsnap-autoconf-1.0.33/libcperciva/events/events_network_selectstats.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/events/events_network_selectstats.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,106 @@
+#include <sys/time.h>
+
+#include "monoclock.h"
+
+#include "events.h"
+#include "events_internal.h"
+
+/* Time when inter-select duration clock started. */
+static struct timeval st;
+static int running = 0;
+
+/* Statistics on inter-select durations. */
+static double N = 0.0;
+static double mu = 0.0;
+static double M2 = 0.0;
+static double max = 0.0;
+
+/**
+ * events_network_selectstats_startclock(void):
+ * Start the inter-select duration clock: There is a selectable event.
+ */
+void
+events_network_selectstats_startclock(void)
+{
+
+	/* If the clock is already running, return silently. */
+	if (running)
+		return;
+
+	/* Get the current time; return silently on error. */
+	if (monoclock_get(&st))
+		return;
+
+	/* The clock is now running. */
+	running = 1;
+}
+
+/**
+ * events_network_selectstats_stopclock(void):
+ * Stop the inter-select duration clock: There are no selectable events.
+ */
+void
+events_network_selectstats_stopclock(void)
+{
+
+	/* The clock is no longer running. */
+	running = 0;
+}
+
+/**
+ * events_network_selectstats_select(void):
+ * Update inter-select duration statistics in relation to an upcoming
+ * select(2) call.
+ */
+void
+events_network_selectstats_select(void)
+{
+	struct timeval tnow;
+	double t, d;
+
+	/* If the clock is not running, return silently. */
+	if (!running)
+		return;
+
+	/* If we can't get the current time, fail silently. */
+	if (monoclock_get(&tnow))
+		goto done;
+
+	/* Compute inter-select duration in seconds. */
+	t = (tnow.tv_sec - st.tv_sec) + (tnow.tv_usec - st.tv_usec) * 0.000001;
+
+	/* Adjust statistics.  We track running mean, variance * N, and max. */
+	N += 1.0;
+	d = t - mu;
+	mu += d / N;
+	M2 += d * (t - mu);
+	if (max < t)
+		max = t;
+
+done:
+	/* The clock is no longer running. */
+	running = 0;	
+}
+
+/**
+ * events_network_selectstats(N, mu, va, max):
+ * Return statistics on the inter-select durations since the last time this
+ * function was called.
+ */
+void
+events_network_selectstats(double * _N, double * _mu, double * _va,
+    double * _max)
+{
+
+	/* Copy statistics out. */
+	*_N = N;
+	*_mu = mu;
+	if (N > 1.0)
+		*_va = M2 / (N - 1.0);
+	else
+		*_va = 0.0;
+	*_max = max;
+
+	/* Zero statistics. */
+	N = mu = M2 = max = 0.0;
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/events/events_timer.c tarsnap-autoconf-1.0.34/libcperciva/events/events_timer.c
--- tarsnap-autoconf-1.0.33/libcperciva/events/events_timer.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/events/events_timer.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,262 @@
+#include <sys/time.h>
+
+#include <stdlib.h>
+#include <string.h>
+
+#include "monoclock.h"
+#include "timerqueue.h"
+
+#include "events_internal.h"
+#include "events.h"
+
+struct timerrec {
+	struct eventrec * r;
+	void * cookie;
+	struct timeval tv_orig;
+};
+
+static struct timerqueue * Q = NULL;
+
+/**
+ * events_timer_register(func, cookie, timeo):
+ * Register ${func}(${cookie}) to be run ${timeo} in the future.  Return a
+ * cookie which can be passed to events_timer_cancel or events_timer_reset.
+ */
+void *
+events_timer_register(int (*func)(void *), void * cookie,
+    const struct timeval * timeo)
+{
+	struct eventrec * r;
+	struct timerrec * t;
+	struct timeval tv;
+
+	/* Create the timer queue if it doesn't exist yet. */
+	if (Q == NULL) {
+		if ((Q = timerqueue_init()) == NULL)
+			goto err0;
+	}
+
+	/* Bundle into an eventrec record. */
+	if ((r = events_mkrec(func, cookie)) == NULL)
+		goto err0;
+
+	/* Create a timer record. */
+	if ((t = malloc(sizeof(struct timerrec))) == NULL)
+		goto err1;
+	t->r = r;
+	memcpy(&t->tv_orig, timeo, sizeof(struct timeval));
+
+	/* Compute the absolute timeout. */
+	if (monoclock_get(&tv))
+		goto err2;
+	tv.tv_sec += t->tv_orig.tv_sec;
+	if ((tv.tv_usec += t->tv_orig.tv_usec) >= 1000000) {
+		tv.tv_usec -= 1000000;
+		tv.tv_sec += 1;
+	}
+
+	/* Add this to the timer queue. */
+	if ((t->cookie = timerqueue_add(Q, &tv, t)) == NULL)
+		goto err2;
+
+	/* Success! */
+	return (t);
+
+err2:
+	free(t);
+err1:
+	events_freerec(r);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * events_timer_register_double(func, cookie, timeo):
+ * As events_timer_register, but ${timeo} is a double-precision floating point
+ * value specifying a number of seconds.
+ */
+void *
+events_timer_register_double(int (*func)(void *), void * cookie,
+    double timeo)
+{
+	struct timeval tv;
+
+	/* Convert timeo to a struct timeval. */
+	tv.tv_sec = timeo;
+	tv.tv_usec = (timeo - tv.tv_sec) * 1000000.0;
+
+	/* Schedule the timeout. */
+	return (events_timer_register(func, cookie, &tv));
+}
+
+/**
+ * events_timer_cancel(cookie):
+ * Cancel the timer for which the cookie ${cookie} was returned by
+ * events_timer_register.
+ */
+void
+events_timer_cancel(void * cookie)
+{
+	struct timerrec * t = cookie;
+
+	/* Remove from the timer queue. */
+	timerqueue_delete(Q, t->cookie);
+
+	/* Free the eventrec and timer records. */
+	events_freerec(t->r);
+	free(t);
+}
+
+/**
+ * events_timer_reset(cookie):
+ * Reset the timer for which the cookie ${cookie} was returned by
+ * events_timer_register to its initial value.
+ */
+int
+events_timer_reset(void * cookie)
+{
+	struct timerrec * t = cookie;
+	struct timeval tv;
+
+	/* Compute the new timeout. */
+	if (monoclock_get(&tv))
+		goto err0;
+	tv.tv_sec += t->tv_orig.tv_sec;
+	if ((tv.tv_usec += t->tv_orig.tv_usec) >= 1000000) {
+		tv.tv_usec -= 1000000;
+		tv.tv_sec += 1;
+	}
+
+	/* Adjust the timer. */
+	timerqueue_increase(Q, t->cookie, &tv);
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * events_timer_min(timeo):
+ * Return via ${timeo} a pointer to the minimum time which must be waited
+ * before a timer will expire; or to NULL if there are no timers.  The caller
+ * is responsible for freeing the returned pointer.
+ */
+int
+events_timer_min(struct timeval ** timeo)
+{
+	struct timeval tnow;
+	const struct timeval * tv;
+
+	/* If we have no queue, we have no timers; return NULL. */
+	if (Q == NULL) {
+		*timeo = NULL;
+		goto done;
+	}
+
+	/* Get the minimum timer from the queue. */
+	tv = timerqueue_getmin(Q);
+
+	/* If there are no timers, return NULL. */
+	if (tv == NULL) {
+		*timeo = NULL;
+		goto done;
+	}
+
+	/* Allocate space for holding the returned timeval. */
+	if ((*timeo = malloc(sizeof(struct timeval))) == NULL)
+		goto err0;
+
+	/* Get the current time... */
+	if (monoclock_get(&tnow))
+		goto err1;
+
+	/* ... and compare it to the minimum timer. */
+	if ((tnow.tv_sec > tv->tv_sec) ||
+	    ((tnow.tv_sec == tv->tv_sec) && (tnow.tv_usec > tv->tv_usec))) {
+		/* The timer has already expired, so return zero. */
+		(*timeo)->tv_sec = 0;
+		(*timeo)->tv_usec = 0;
+	} else {
+		/* Compute the difference. */
+		(*timeo)->tv_sec = tv->tv_sec - tnow.tv_sec;
+		(*timeo)->tv_usec = tv->tv_usec - tnow.tv_usec;
+		if (tv->tv_usec < tnow.tv_usec) {
+			(*timeo)->tv_usec += 1000000;
+			(*timeo)->tv_sec -= 1;
+		}
+	}
+
+done:
+	/* Success! */
+	return (0);
+
+err1:
+	free(*timeo);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * events_timer_get(r):
+ * Return via ${r} a pointer to an eventrec structure corresponding to an
+ * expired timer, and delete said timer; or to NULL if there are no expired
+ * timers.  The caller is responsible for freeing the returned pointer.
+ */
+int
+events_timer_get(struct eventrec ** r)
+{
+	struct timeval tnow;
+	struct timerrec * t;
+
+	/* If we have no queue, we have no timers; return NULL. */
+	if (Q == NULL) {
+		*r = NULL;
+		goto done;
+	}
+
+	/* Get current time. */
+	if (monoclock_get(&tnow))
+		goto err0;
+
+	/* Get an expired timer, if there is one. */
+	t = timerqueue_getptr(Q, &tnow);
+
+	/* If there is an expired timer... */
+	if (t != NULL) {
+		/* ... pass back the eventrec and free the timer. */
+		*r = t->r;
+		free(t);
+	} else {
+		/* Otherwise, return NULL. */
+		*r = NULL;
+	}
+
+done:
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * events_timer_shutdown(void):
+ * Clean up and free memory.  This call is not necessary on program exit and
+ * is only expected to be useful when checking for memory leaks.
+ */
+void
+events_timer_shutdown(void)
+{
+
+	/* If we have a queue and it is empty, free it. */
+	if ((Q != NULL) && (timerqueue_getmin(Q) == NULL)) {
+		timerqueue_free(Q);
+		Q = NULL;
+	}
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/network/network.h tarsnap-autoconf-1.0.34/libcperciva/network/network.h
--- tarsnap-autoconf-1.0.33/libcperciva/network/network.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/network/network.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,95 @@
+#ifndef _NETWORK_H_
+#define _NETWORK_H_
+
+#include <sys/select.h>
+
+#include <stddef.h>
+#include <stdint.h>
+#include <unistd.h>
+
+/* Opaque address structure. */
+struct sock_addr;
+
+/**
+ * network_accept(fd, callback, cookie):
+ * Asynchronously accept a connection on the socket ${fd}, which must be
+ * already marked as listening and non-blocking.  When a connection has been
+ * accepted or an error occurs, invoke ${callback}(${cookie}, s) where s is
+ * the accepted connection or -1 on error.  Return a cookie which can be
+ * passed to network_accept_cancel in order to cancel the accept.
+ */
+void * network_accept(int, int (*)(void *, int), void *);
+
+/**
+ * network_accept_cancel(cookie);
+ * Cancel the connection accept for which the cookie ${cookie} was returned
+ * by network_accept.  Do not invoke the callback associated with the accept.
+ */
+void network_accept_cancel(void *);
+
+/**
+ * network_connect(sas, callback, cookie):
+ * Iterate through the addresses in ${sas}, attempting to create and connect
+ * a non-blocking socket.  Once connected, invoke ${callback}(${cookie}, s)
+ * where s is the connected socket; upon fatal error or if there are no
+ * addresses remaining to attempt, invoke ${callback}(${cookie}, -1).  Return
+ * a cookie which can be passed to network_connect_cancel in order to cancel
+ * the connection attempt.
+ */
+void * network_connect(struct sock_addr * const *,
+    int (*)(void *, int), void *);
+
+/**
+ * network_connect_timeo(sas, timeo, callback, cookie):
+ * Behave as network_connect, but wait a duration of at most ${timeo} for
+ * each address which is being attempted.
+ */
+void * network_connect_timeo(struct sock_addr * const *, const struct timeval *,
+    int (*)(void *, int), void *);
+
+/**
+ * network_connect_cancel(cookie):
+ * Cancel the connection attempt for which ${cookie} was returned by
+ * network_connect.  Do not invoke the associated callback.
+ */
+void network_connect_cancel(void *);
+
+/**
+ * network_read(fd, buf, buflen, minread, callback, cookie):
+ * Asynchronously read up to ${buflen} bytes of data from ${fd} into ${buf}.
+ * When at least ${minread} bytes have been read or on error, invoke
+ * ${callback}(${cookie}, lenread), where lenread is 0 on EOF or -1 on error,
+ * and the number of bytes read (between ${minread} and ${buflen} inclusive)
+ * otherwise.  Return a cookie which can be passed to network_read_cancel in
+ * order to cancel the read.
+ */
+void * network_read(int, uint8_t *, size_t, size_t,
+    int (*)(void *, ssize_t), void *);
+
+/**
+ * network_read_cancel(cookie):
+ * Cancel the buffer read for which the cookie ${cookie} was returned by
+ * network_read.  Do not invoke the callback associated with the read.
+ */
+void network_read_cancel(void *);
+
+/**
+ * network_write(fd, buf, buflen, minwrite, callback, cookie):
+ * Asynchronously write up to ${buflen} bytes of data from ${buf} to ${fd}.
+ * When at least ${minwrite} bytes have been written or on error, invoke
+ * ${callback}(${cookie}, lenwrit), where lenwrit is -1 on error and the
+ * number of bytes written (between ${minwrite} and ${buflen} inclusive)
+ * otherwise.  Return a cookie which can be passed to network_write_cancel in
+ * order to cancel the write.
+ */
+void * network_write(int, const uint8_t *, size_t, size_t,
+    int (*)(void *, ssize_t), void *);
+
+/**
+ * network_write_cancel(cookie):
+ * Cancel the buffer write for which the cookie ${cookie} was returned by
+ * network_write.  Do not invoke the callback associated with the write.
+ */
+void network_write_cancel(void *);
+
+#endif /* !_NETWORK_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/network/network_accept.c tarsnap-autoconf-1.0.34/libcperciva/network/network_accept.c
--- tarsnap-autoconf-1.0.33/libcperciva/network/network_accept.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/network/network_accept.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,103 @@
+#include <sys/types.h>
+#include <sys/socket.h>
+
+#include <errno.h>
+#include <stdlib.h>
+
+#include "events.h"
+
+#include "network.h"
+
+struct accept_cookie {
+	int (* callback)(void *, int);
+	void * cookie;
+	int fd;
+};
+
+/* Accept the connection and invoke the callback. */
+static int
+callback_accept(void * cookie)
+{
+	struct accept_cookie * C = cookie;
+	int s;
+	int rc;
+
+	/* Attempt to accept a new connection. */
+	if ((s = accept(C->fd, NULL, NULL)) == -1) {
+		/* If a connection isn't available, reset the callback. */
+		if ((errno == EAGAIN) ||
+		    (errno == EWOULDBLOCK) ||
+		    (errno == ECONNABORTED) ||
+		    (errno == EINTR))
+			goto tryagain;
+	}
+
+	/* Call the upstream callback. */
+	rc = (C->callback)(C->cookie, s);
+
+	/* Free the cookie. */
+	free(C);
+
+	/* Return status from upstream callback. */
+	return (rc);
+
+tryagain:
+	/* Reset the callback. */
+	return (events_network_register(callback_accept, C, C->fd,
+	    EVENTS_NETWORK_OP_READ));
+}
+
+/**
+ * network_accept(fd, callback, cookie):
+ * Asynchronously accept a connection on the socket ${fd}, which must be
+ * already marked as listening and non-blocking.  When a connection has been
+ * accepted or an error occurs, invoke ${callback}(${cookie}, s) where s is
+ * the accepted connection or -1 on error.  Return a cookie which can be
+ * passed to network_accept_cancel in order to cancel the accept.
+ */
+void *
+network_accept(int fd, int (* callback)(void *, int), void * cookie)
+{
+	struct accept_cookie * C;
+
+	/* Bake a cookie. */
+	if ((C = malloc(sizeof(struct accept_cookie))) == NULL)
+		goto err0;
+	C->callback = callback;
+	C->cookie = cookie;
+	C->fd = fd;
+
+	/*
+	 * Register a network event.  A connection arriving on a listening
+	 * socket is treated by select(2) as the socket becoming readable.
+	 */
+	if (events_network_register(callback_accept, C, C->fd,
+	    EVENTS_NETWORK_OP_READ))
+		goto err1;
+
+	/* Success! */
+	return (C);
+
+err1:
+	free(C);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * network_accept_cancel(cookie);
+ * Cancel the connection accept for which the cookie ${cookie} was returned
+ * by network_accept.  Do not invoke the callback associated with the accept.
+ */
+void
+network_accept_cancel(void * cookie)
+{
+	struct accept_cookie * C = cookie;
+
+	/* Cancel the network event. */
+	events_network_cancel(C->fd, EVENTS_NETWORK_OP_READ);
+
+	/* Free the cookie. */
+	free(C);
+}
